package com.rjconsultores.ventaboletos.dao.hibernate;

import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

import com.rjconsultores.ventaboletos.dao.GP_PricingTipoPtoVtaDAO;
import com.rjconsultores.ventaboletos.entidad.GP_Pricing;
import com.rjconsultores.ventaboletos.entidad.GP_PricingTipoPtoVta;
import com.rjconsultores.ventaboletos.entidad.TipoPuntoVenta;

@Repository("gp_pricingTipoPtoVtaDAO")
public class GP_PricingTipoPtoVtaHibernateDAO extends GenericHibernateDAO<GP_PricingTipoPtoVta, Integer>
        implements GP_PricingTipoPtoVtaDAO {

    @Autowired
    public GP_PricingTipoPtoVtaHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
        setSessionFactory(factory);
    }

    @Override
    public List<GP_PricingTipoPtoVta> obtenerTodos() {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq(ACTIVO, GP_Pricing.ATIVO));

        return c.list();
    }

    public Boolean obtenerPricingTipoPuntoVenta(GP_Pricing pricing, TipoPuntoVenta tipoPuntoVenta) {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq(ACTIVO, GP_Pricing.ATIVO));
        c.add(Restrictions.eq("pricing", pricing));
        c.add(Restrictions.eq("tipoPtovta", tipoPuntoVenta));

        if (c.list().size() > 0) {
            return true;
        } else {
            return false;
        }
    }

	@Override
	public List<GP_PricingTipoPtoVta> obtenerTodoPorPricing(GP_Pricing pricing) {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq("pricing.pricingId", pricing.getPricingId()));

		return c.list();
	}
}
